//
//  IMDB.m
//  DVDpedia
//
//  Created by Conor Dearden on 22/2/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import "IMDB.h"
#import "IMDBOptionsPanel.h"
#import "Constants.h"


@interface NSObject (forPluginsNotToWarn) 

- (void)addCreditsFromSection:(NSString *)creditsSection to:(NSMutableDictionary *)resultsDict;
- (void)addCreditsFromSection:(NSString *)creditsSection withRole:(NSString *)aRole to:(NSMutableDictionary *)resultsDict;

- (void)amazonImageForAsin:(NSString *)anAsin toImageArray:(NSMutableArray *)anArray;

- (NSMutableDictionary *)oldIMDBParsingStyle:(NSString *)aString imdbNumber:(NSString *)imdbNumber;
// :ToIn:20090409
- (void)addAdditionalPlotKeywordsFromSection:(NSString *)plotKeywordsSection to:(NSMutableDictionary *)resultsDict;
@end



@implementation IMDB

#pragma mark Init
+ (id)plugin;
{ 
    return [[[self alloc] init] autorelease];
}

- (id)init {
	if (self = [super init]) {
		resultsTitle = [[NSMutableArray array] retain];
		resultsIMDBNumber = [[NSMutableArray array] retain];
	}
	return self;
}

- (void)dealloc {
	[resultsTitle release];
	[resultsIMDBNumber release];
	[super dealloc];
}

#pragma mark Menu
- (NSArray *)menuCommandFor:(NSMutableArray *)entries {
	if (preferenceWindow == nil) {
		if (![NSBundle loadNibNamed:@"IMDBPreferences.nib" owner:self] ) {
			NSLog(@"IMDBPreferences.nib Failed");
		}
	}
	
	[preferenceWindow showPreferences];
	return nil;
}

#pragma mark -
#pragma mark Search
- (void)searchFor:(NSDictionary *)searchDict sender:(id)sender{
	
	
	//BOOL block = NO;
	[delegate release];
	[resultsTitle removeAllObjects];
	[resultsIMDBNumber removeAllObjects];
	
	if ([sender isKindOfClass:[NSString class]] && [sender isEqualToString:@"Block"]) {
	//	block = YES;
		delegate = nil;
	}
	else {
		delegate = [sender retain];
	}
	NSString *urlString= nil;
	
	if ([searchDict objectForKey:@"keyword"]) {
		urlString = [searchDict objectForKey:@"keyword"];
		//urlString = (NSString*)CFURLCreateStringByAddingPercentEscapes(NULL, (CFStringRef)[searchDict objectForKey:@"keyword"], NULL, (CFStringRef)@"&+", kCFStringEncodingUTF8);
	}
	else if ([searchDict objectForKey:@"imdb"]) {
		urlString = [searchDict objectForKey:@"imdb"];
	}
	else if ([searchDict objectForKey:@"originalTitle"]) {
		urlString = [searchDict objectForKey:@"originalTitle"];
	}
	else if ([searchDict objectForKey:@"title"]) {
		urlString = [searchDict objectForKey:@"title"];
	}
	else if ([searchDict objectForKey:@"director"]) {
		urlString = [searchDict objectForKey:@"director"];
	}
	else if ([searchDict objectForKey:@"starring"]) {
		urlString = [searchDict objectForKey:@"starring"];
	}
	else {
		[sender searchReturnedNumberOfResults:0 sender:self];
	}
		
	
	if ([urlString length] == 7 && [urlString intValue] > 0) {
		NSCharacterSet *notDigitsSet = [[NSCharacterSet decimalDigitCharacterSet] invertedSet];
		NSString *removeNonDigits = [urlString stringByTrimmingCharactersInSet:notDigitsSet];
		if ([removeNonDigits length] == 7) {
			[resultsIMDBNumber addObject:urlString];
			[resultsTitle addObject:[NSString stringWithFormat:@"IMDB #:%@", urlString]];
			[delegate searchReturnedNumberOfResults:1 sender:self];
			return;
		}
	}
	
	//NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];

	// La+B%EAte
	urlString = [urlString stringByAddingPercentEscapesUsingEncoding:NSISOLatin1StringEncoding];
	
	//NSString *httpRequest = [NSString stringWithFormat:@"http://imdb.com/find?tt=on;nm=on;mx=20;q=%@", urlString];
	NSString *httpRequest = [NSString stringWithFormat:@"http://imdb.com/find?s=all&q=%@", urlString];
	
	[akasRequest release];
	akasRequest = [[NSString stringWithFormat:@"http://akas.imdb.com/find?s=all&q=%@", urlString] retain];
	
	[self downloadWebPage:httpRequest];
	//[pool release];
}

	
- (void)downloadComplete:(NSString *)HTMLSource {
	
	if (HTMLSource != nil) {
		NSScanner *searchScanner = [NSScanner scannerWithString:HTMLSource];
		NSString *tempString = nil;		
		
		//if ([HTMLSource rangeOfString:@"Plot Keywords:"].location != NSNotFound || [HTMLSource rangeOfString:@"Plot Synopsis:<"].location != NSNotFound)  {
		if ([HTMLSource rangeOfString:@"<h6>Overview</h6>"].location != NSNotFound)  {
			NSString *title = nil;
			[searchScanner scanUpToString:@"<title>" intoString:nil];
			[searchScanner scanUpToString:@"</title>" intoString:&title];
			if ([title hasPrefix:@"<title>"])
				title = [[title substringFromIndex:7] stringByCleaningHTML];
			
			[searchScanner scanUpToString:@"/title/tt" intoString:nil];
			if (![searchScanner isAtEnd]) {
				[searchScanner setScanLocation:[searchScanner scanLocation] +9];
				[searchScanner scanUpToString:@"\"" intoString:&tempString];
				int location;
				if ((location = [tempString rangeOfString:@"/"].location) != NSNotFound)
					tempString = [tempString substringToIndex:location];
				
				if ([tempString intValue]) {
					[resultsIMDBNumber insertObject:tempString atIndex:0];
					[resultsTitle insertObject:title atIndex:0];
				}				
			}
		}
		else {
			//NSString *type = @"9";
			int i = 0;
			while (1) {
				tempString = nil;
				//NSString *textBetween = nil;
				[searchScanner scanUpToString:@"<a href=\"/title/tt" intoString:nil];
				
				/*
				 if ([textBetween rangeOfString:@"<b>Popular Titles"].location != NSNotFound)
				 type = @"1";
				 else if ([textBetween rangeOfString:@"(Exact Matches)<"].location != NSNotFound)
				 type = @"2";
				 else if ([textBetween rangeOfString:@"(Approx Matches)<"].location != NSNotFound)
				 type = @"3";
				 */
				
				
				if (![searchScanner isAtEnd]) {
					[searchScanner setScanLocation:[searchScanner scanLocation] + 18];
					[searchScanner scanUpToString:@"/" intoString:&tempString];
					NSString *imdbNumber = tempString;
					[searchScanner scanUpToString:@"\">" intoString:nil];
					[searchScanner scanUpToString:@"</" intoString:&tempString];
					NSString *tempTitle = [tempString substringFromIndex:2];
					if (![tempTitle hasPrefix:@"<"]) {
						tempTitle = [tempTitle stringByCleaningHTML];
						[searchScanner setScanLocation:[searchScanner scanLocation] + 1];
						[searchScanner scanUpToString:@"<" intoString:&tempString];
						if ([tempString hasPrefix:@"/a> ("]) {
							tempTitle = [NSString stringWithFormat:@"%@ (%d)", tempTitle, [[tempString substringFromIndex:5] intValue]];
						}
						// Add only if not present already
						if (![resultsTitle containsObject:tempTitle]) {
							if (akasRequest == nil) {
								[resultsTitle insertObject:tempTitle atIndex:i];
								[resultsIMDBNumber insertObject:imdbNumber atIndex:i];
								i++;
							}
							else {
								[resultsTitle addObject:tempTitle];
								[resultsIMDBNumber addObject:imdbNumber];
							}
						}
					}
				}
				else {
					break; 
				}
			}
		}
	}
	
	// if the page does not have a popular match or exact match serach the akas as well
	if (akasRequest != nil && [resultsIMDBNumber count] != 1 && HTMLSource && [HTMLSource rangeOfString:@"<b>Popular"].location == NSNotFound && [HTMLSource rangeOfString:@"(Exact Matches)</b>"].location == NSNotFound) {
		[self downloadWebPage:[akasRequest autorelease]];
		akasRequest = nil;
	}
	else
		[delegate searchReturnedNumberOfResults:[resultsIMDBNumber count] sender:self];
}


- (NSDictionary *)resultNumber:(int)number {
	NSMutableDictionary *resultsDict = [NSMutableDictionary dictionary];
	
	if (number >= [resultsIMDBNumber count]) {
		NSLog(@"Error: IMDB number for requsted out of range number %d", number);
		[resultsDict setObject:@"No Data Found on IMDB" forKey:@"title"];
		return resultsDict;	
	}
	
	//NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	NSString *imdbNumber = [resultsIMDBNumber objectAtIndex:number];
	NSString *detailsURL = [NSString stringWithFormat:@"http://imdb.com/title/tt%@", imdbNumber];
	NSURLRequest *theRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:detailsURL] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:30.0];
	
	NSString *results = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:theRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
	
	if (results == nil) {
		//[pool release];
		return nil;
	}
	
	// Detect if it's old version and then use the olf version parsing. This is a preference users can select when logged in;
	// New version has <div id="tn15" class="maindetails">
	if ([results rangeOfString:@"id=\"tn15\""].location == NSNotFound) {
		resultsDict = [self oldIMDBParsingStyle:results imdbNumber:imdbNumber];
	}
	else {
		
		/*
		 NSMutableString *imdbResults = [NSMutableString stringWithCapacity:200]; 
		 [imdbResults setString: results];
		 NSScanner *searchScanner;
		 while (YES) {
		 int tempInt = 0;
		 searchScanner = [NSScanner scannerWithString:imdbResults];
		 [searchScanner scanUpToString:@"&#" intoString:nil];
		 if ([searchScanner isAtEnd])
		 break;
		 [searchScanner setScanLocation:[searchScanner scanLocation] +2];
		 [searchScanner scanInt:&tempInt];
		 
		 if (tempInt)
		 [imdbResults replaceOccurrencesOfString:[NSString stringWithFormat:@"&#%d;", tempInt] withString:[NSString stringWithFormat:@"%C", tempInt]  options:NSLiteralSearch range:NSMakeRange(0, [imdbResults length])];
		 else 
		 [imdbResults deleteCharactersInRange:NSMakeRange([searchScanner scanLocation] -2,2)];
		 //delete error &# that should not exist;
		 }
		 */
		
		[resultsDict setObject:detailsURL forKey:@"url"];
		
		NSScanner *searchScanner = [NSScanner scannerWithString:results];
		
		[resultsDict setValue:imdbNumber forKey:@"imdb"];
		NSMutableArray *imageLocationArray = [NSMutableArray array];
		[resultsDict setObject:imageLocationArray forKey:@"imageLocationArray"];
		
		NSString *tempString = nil;
		[searchScanner scanUpToString:@"name=\"poster" intoString:nil];
		[searchScanner scanUpToString:@"http://ia." intoString:nil];
		//[searchScanner scanUpToString:@"http://ia.imdb.com/media" intoString:nil];
		[searchScanner scanUpToString:@"\"" intoString:&tempString];
		
		if ([tempString hasPrefix:@"http://ia."] && ([tempString rangeOfString:@".media-imdb"].location != NSNotFound || [tempString rangeOfString:@"/media/"].location != NSNotFound)) {
			[imageLocationArray addObject:tempString];
			
			//http://ia.media-imdb.com/images/M/MV5BMTI0MTg1NzQzMV5BMl5BanBnXkFtZTcwNzYwMDQyMQ@@._V1._SY400_SX600_.jp
			//http://ia.media-imdb.com/images/M/MV5BMTI0MTg1NzQzMV5BMl5BanBnXkFtZTcwNzYwMDQyMQ@@._V1._SY140_SX100_.jpg
			//http://ia.media-imdb.com/images/M/MV5BMTI0MTg1NzQzMV5BMl5BanBnXkFtZTcwNzYwMDQyMQ@@._V1._SX5000_SY5000_.jpg
			NSInteger startSX = [tempString rangeOfString:@"_SX"].location;
			if (startSX != NSNotFound) {
				startSX = startSX + 3;
				NSInteger endSX = [tempString rangeOfString:@"_" options:0 range:NSMakeRange(startSX , [tempString length] - startSX)].location;

				NSMutableString *largerImageURL = [NSMutableString stringWithString:tempString];
				if (endSX != NSNotFound) {
					[largerImageURL replaceCharactersInRange:NSMakeRange(startSX, endSX - startSX) withString:@"1000"];
					
				}
				
				
				NSInteger startSY = [largerImageURL rangeOfString:@"_SY"].location;
				startSY = startSY + 3;
				NSInteger endSY = [largerImageURL rangeOfString:@"_" options:0 range:NSMakeRange(startSY, [largerImageURL length] - startSY)].location;
				if (startSY != NSNotFound && endSY != NSNotFound) {
					[largerImageURL replaceCharactersInRange:NSMakeRange(startSY, endSY - startSY) withString:@"1000"];
				}				
				
				[imageLocationArray insertObject:largerImageURL atIndex:0];
				
				//[largerImageURL replaceOccurrencesOfString:@"SX100_" withString:@"SX600_" options:NSLiteralSearch range:NSMakeRange(0, [largerImageURL length])];
				//[largerImageURL replaceOccurrencesOfString:@"SY140_" withString:@"SX400_" options:NSLiteralSearch range:NSMakeRange(0, [largerImageURL length])];
			}
			
			//[resultsDict setValue:tempString forKey:@"imageLocation"];
		}
		else {
			[searchScanner setScanLocation:0];
		}
		
		
		NSString *movieTitle = nil;
		[searchScanner scanUpToString:@"tn15title\">" intoString:nil];
		[searchScanner scanUpToString:@"h1>" intoString:nil];
		[searchScanner scanUpToString:@"<" intoString:&movieTitle];
		
		if ([movieTitle hasPrefix:@"h1>"]) {
			movieTitle = [movieTitle substringFromIndex:3];
			movieTitle = [movieTitle stringByCleaningHTML];
			
			//clean quotes at ends if necessary
			if ([movieTitle hasPrefix:@"\""] && [movieTitle hasSuffix:@"\""]) {
				movieTitle = [movieTitle substringWithRange:NSMakeRange(1, [movieTitle length] - 2)];
			}
			[resultsDict setValue:movieTitle forKey:@"title"];
		}
		else {
			[searchScanner setScanLocation:0];
		}
		
		
		tempString = nil;
		[searchScanner scanUpToString:@"\"/year/" intoString:nil];
		[searchScanner scanUpToString:@"\">" intoString:&tempString];
		
		if ([tempString hasPrefix:@"\"/year/"]) {
			tempString = [tempString substringFromIndex:7];
			if ([tempString hasSuffix:@"/"])
				tempString = [tempString substringToIndex:[tempString length] -1];

			NSDate *tempDate = [NSDate dateWithNaturalLanguageString:tempString locale:nil];
			if (tempDate) {
				tempDate = [tempDate dateAtBeginningOfYear];
				[resultsDict setValue:tempDate forKey:@"theatrical"];
			}
		}
		else {
			[searchScanner setScanLocation:0];
		}
		
		//More specific release date
		tempString = nil;
		[searchScanner scanUpToString:@"Release Date:</h5>" intoString:nil];
		[searchScanner scanUpToString:@">" intoString:nil];
		[searchScanner scanUpToString:@"</" intoString:&tempString];
		if ([tempString hasPrefix:@">"]) {
			tempString = [tempString substringFromIndex:1];
			NSInteger location = [tempString rangeOfString:@"<a "].location;
			if (location != NSNotFound)
				tempString = [tempString substringToIndex:location];
			if ((location = [tempString rangeOfString:@"("].location) != NSNotFound)
				tempString = [tempString substringToIndex:location];
			tempString = [tempString stringByCleaningHTML];
			NSDate *aDate = [NSDate dateWithNaturalLanguageString:tempString];
			
			if (aDate) {
				//IMDb gives you the year for the users country, so only add specific date if the years match 
				NSDate *previousDate = [resultsDict valueForKey:@"theatrical"];
				if (previousDate == nil || [[previousDate descriptionWithCalendarFormat:@"%Y" timeZone:nil locale:nil] isEqualToString:[aDate descriptionWithCalendarFormat:@"%Y" timeZone:nil locale:nil]])
					[resultsDict setValue:aDate forKey:@"theatrical"];
			}
		}	
		[searchScanner setScanLocation:0];
		
		
		tempString = nil;
		NSString *rating = nil;
		NSString *totalVotes = @"";
		// User Raiting: has javascript in between when logged in that stops the rating from coming in 
		[searchScanner scanUpToString:@"\"starbar-meta\"" intoString:nil];
		[searchScanner scanUpToString:@"<b>" intoString:nil];
		[searchScanner scanUpToString:@"/" intoString:&tempString];
		[searchScanner scanUpToString:@"\">" intoString:nil];
		[searchScanner scanUpToString:@" votes" intoString:&totalVotes];
		if (tempString == nil) {
			[searchScanner scanUpToString:@"\"general rating\"" intoString:nil];
			[searchScanner scanUpToString:@"<b>" intoString:nil];
			[searchScanner scanUpToString:@"/" intoString:&tempString];
			[searchScanner scanUpToString:@"\">" intoString:nil];
			[searchScanner scanUpToString:@" votes" intoString:&totalVotes];
		}
		
		if ([tempString hasPrefix:@"<b>"]) {
			rating = [tempString substringFromIndex:3];
			
			if ([rating intValue]) {
				if ([totalVotes hasPrefix:@"\">"]) {
					totalVotes = [totalVotes substringFromIndex:2];
					if ([totalVotes intValue]) {
						rating = [NSString stringWithFormat:[[NSBundle bundleWithIdentifier:@"com.bruji.pediabase"] localizedStringForKey:@"votes" value:@"%@ (%@ votes)" table:@"Localizable"], rating, totalVotes];
					}
				}
				
				[resultsDict setValue:rating forKey:@"rating"];
			}
		}	
		
		[searchScanner setScanLocation:0];
		tempString = nil;
		int myRating = 0;
		[searchScanner scanUpToString:@"\"voteuser\">" intoString:nil];
		[searchScanner scanUpToString:@">" intoString:nil];
		[searchScanner scanUpToString:@"<" intoString:&tempString];
		if ([tempString hasPrefix:@">"]) {
			myRating = [[tempString substringFromIndex:1] intValue];
			if (myRating) {
				NSNumber *myRatingNumber = [NSNumber numberWithInt:myRating/2];
				[resultsDict setValue:myRatingNumber forKey:@"myRating"];
			}
		}	
		
		
		[searchScanner setScanLocation:0];
		tempString = nil;
		[searchScanner scanUpToString:@"h5>Director" intoString:nil];
		[searchScanner scanUpToString:@"</div>" intoString:&tempString];
		
		if (tempString) {
			NSScanner *scanTemp;
			
			scanTemp = [NSScanner scannerWithString:tempString];
			[scanTemp scanUpToString:@"/name/nm" intoString:nil];
			[scanTemp scanUpToString:@"\">" intoString:nil];
			
			NSString *director = @"";
			
			if (![scanTemp isAtEnd])  {
				
				while (YES){
					NSString *tempStringTwo = @"";
					
					[scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
					[scanTemp scanUpToString:@"/name/nm" intoString:nil];
					[scanTemp scanUpToString:@"\">" intoString:nil];
					
					if ([tempStringTwo hasPrefix:@"\">"]) {
						tempStringTwo = [tempStringTwo substringFromIndex:2];
					}
					
					if ([scanTemp isAtEnd]) {
						director = [NSString stringWithFormat:@"%@%@", director, tempStringTwo];
						break;
					}
					else {
						director = [NSString stringWithFormat:@"%@%@, ", director, tempStringTwo];
					}
				}
			}
			
			if (![director isEqualToString:@""])
				[resultsDict setValue:[director stringByCleaningHTML] forKey:@"director"];
		}
		else {
			[searchScanner setScanLocation:0];
		}
		
		tempString = nil;
		[searchScanner scanUpToString:@"h5>Writer" intoString:nil];
		[searchScanner scanUpToString:@"</div>" intoString:&tempString];
		if ([searchScanner isAtEnd]) {
			[searchScanner setScanLocation:0];
			[searchScanner scanUpToString:@"/Glossary/W#writer" intoString:nil];
			[searchScanner scanUpToString:@"</table>" intoString:&tempString];	
		}
		
		
		if (tempString) {
			
			NSScanner *scanTemp;
			
			scanTemp = [NSScanner scannerWithString:tempString];
			[scanTemp scanUpToString:@"/name/nm" intoString:nil];
			[scanTemp scanUpToString:@"\">" intoString:nil];
			
			NSString *writer = @"";
			
			if (![scanTemp isAtEnd])  {
				
				while (YES){
					NSString *tempStringTwo = @"";
					[scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
					[scanTemp scanUpToString:@"/name/nm" intoString:nil];
					[scanTemp scanUpToString:@"\">" intoString:nil];
					
					if ([tempStringTwo hasPrefix:@"\">"]) {
						tempStringTwo = [tempStringTwo substringFromIndex:2];
					}
					
					if ([scanTemp isAtEnd]) {
						writer = [NSString stringWithFormat:@"%@%@", writer, tempStringTwo];
						break;
					}
					else {
						writer = [NSString stringWithFormat:@"%@%@, ", writer, tempStringTwo];
					}
				}
			}
			
			if (![writer isEqualToString:@""])
				[resultsDict setValue:[writer stringByCleaningHTML] forKey:@"writer"];
		}
		else {
			[searchScanner setScanLocation:0];
		}
		
		tempString = nil;
		[searchScanner scanUpToString:@">Genre:<" intoString:nil];
		[searchScanner scanUpToString:@"</div" intoString:&tempString];
		NSArray *genres = [tempString stringsBetween:@"/Sections/Genres/" and:@"/"];
		if ([genres count]) {
			[resultsDict setValue:[[genres componentsJoinedByString:@", "] stringByCleaningHTML] forKey:@"genre"];
		}
		else {
			[searchScanner setScanLocation:0];
		}		

		
		tempString = nil;
		[searchScanner scanUpToString:@"Tagline:</h5>" intoString:nil];
		[searchScanner scanUpToString:@"\">" intoString:nil];
		[searchScanner scanUpToString:@"<" intoString:&tempString];
		if ([tempString hasPrefix:@"\">"]) {
			tempString = [[tempString substringFromIndex:2] stringByCleaningHTML];
			[resultsDict setValue:tempString forKey:@"comments"];
		}	
		else {
			[searchScanner setScanLocation:0];
		}
		
		
		NSURLRequest *plotSummaryRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://imdb.com/title/tt%@/plotsummary", imdbNumber]] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:10.0];
		NSString *fullPlotSummary = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:plotSummaryRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
		if (fullPlotSummary) {
			fullPlotSummary = [fullPlotSummary stringBetween:@"=\"plotpar\"" and:@"</p"];
			fullPlotSummary = [fullPlotSummary stringBetween:@">" and:@"<i"];
			[resultsDict setValue:[fullPlotSummary stringByCleaningHTML] forKey:@"summary"];
		}
		/*
		 else {
		 // Try to get the partial summary
		 tempString = nil;
		 [searchScanner scanUpToString:@"Plot Outline:</b>" intoString:nil];
		 [searchScanner scanUpToString:@">" intoString:nil];
		 [searchScanner scanUpToString:@"<" intoString:&tempString];
		 if ([tempString hasPrefix:@">"]) {
		 [resultsDict setValue:[[tempString substringFromIndex:1] stringByCleaningHTML] forKey:@"summary"];
		 }	
		 else {
		 [searchScanner setScanLocation:0];
		 tempString = nil;
		 [searchScanner scanUpToString:@"Plot Summary:</" intoString:nil];
		 [searchScanner scanUpToString:@">" intoString:nil];
		 [searchScanner scanUpToString:@"<" intoString:&tempString];
		 if ([tempString hasPrefix:@">"]) {
		 [resultsDict setValue:[[tempString substringFromIndex:1] stringByCleaningHTML] forKey:@"summary"];
		 }	
		 else {
		 [searchScanner setScanLocation:0];
		 }
		 
		 }
		 }
		 */
		
		
		
		tempString = nil;
		[searchScanner scanUpToString:@"Awards:</h5>" intoString:nil];
		[searchScanner scanUpToString:@">" intoString:&tempString];
		[searchScanner scanUpToString:@"</" intoString:&tempString];
		if ([tempString hasPrefix:@">"]) {
			tempString = [tempString substringFromIndex:1];
			NSInteger location = [tempString rangeOfString:@"<a "].location;
			if (location != NSNotFound)
				tempString = [tempString substringToIndex:location];
			NSMutableString *removeReturns = [NSMutableString stringWithString:[tempString substringFromIndex:1]];
			[removeReturns replaceOccurrencesOfString:@"\n" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[removeReturns length])];
			[removeReturns replaceOccurrencesOfString:@"&amp;" withString:@" & " options:NSLiteralSearch range:NSMakeRange(0,[removeReturns length])];
			
			[resultsDict setValue:[removeReturns stringByCleaningHTML] forKey:@"awards"];
		}	
		else {
			[searchScanner setScanLocation:0];
		}
		
		
		//Set arrays needed for roles and names
		NSMutableArray *creditsArray = [NSMutableArray array];
		[resultsDict setObject:creditsArray forKey:@"credits"];
		
		
		// Scan Actors 
		NSString *creditsSection = @"";
		[searchScanner scanUpToString:@"class=\"cast\"" intoString:nil];
		[searchScanner scanUpToString:@"</table>" intoString:&creditsSection];
		
		//if creditsSection is still empty then reset scan location otherwise get credits
		if (![creditsSection isEqualToString:@""]) {	   
			[self addCreditsFromSection:creditsSection to:resultsDict];
		}
		else
			[searchScanner setScanLocation:0];
		
		
		[searchScanner setScanLocation:0];
		tempString = nil;
		[searchScanner scanUpToString:@"MPAA</a>:</h5>" intoString:nil];
		[searchScanner scanUpToString:@"h5>" intoString:&tempString];
		[searchScanner scanUpToString:@"</" intoString:&tempString];
		if ([tempString hasPrefix:@"h5>"]) {
			tempString = [tempString substringFromIndex:3];
			
			if ([tempString rangeOfString:@"PG-13"].location != NSNotFound) {
				tempString = @"PG-13";
			}
			else if ([tempString rangeOfString:@"PG "].location != NSNotFound) {
				tempString = @"PG";
			}
			else if ([tempString rangeOfString:@"G "].location != NSNotFound) {
				tempString = @"G";
			}
			else if ([tempString rangeOfString:@"NC-17"].location != NSNotFound) {
				tempString = @"NC-17";
			}
			else if ([tempString rangeOfString:@"NR "].location != NSNotFound) {
				tempString = @"NR";
			}
			else if ([tempString rangeOfString:@" R "].location != NSNotFound) {
				tempString = @"R";
			}
			
			[resultsDict setValue:[tempString stringByCleaningHTML] forKey:@"rated"];
			
		}
		else {
			[searchScanner setScanLocation:0];
		}
		
		/*
		// Get UK rating
		tempString = [results stringBetween:@"?certificates=UK" and:@"</"];
		tempString = [tempString stringBetween:@">" and:@"</"];
		tempString = [tempString stringBetween:@":" and:@"</"];
		if (tempString) {
			[resultsDict setValue:tempString forKey:@"rated"];
		}
		 */
		
		//#### TV shows have a seasons page
		
		tempString = nil;
		[searchScanner scanUpToString:@"Runtime:</h5>" intoString:nil];
		[searchScanner scanUpToString:@">" intoString:nil];
		[searchScanner scanUpToString:@"</" intoString:&tempString];
		if ([tempString hasPrefix:@">"]) {
			int runtime;
			tempString = [[tempString substringFromIndex:1] stringByCleaningHTML];
			NSScanner *intScanner = [NSScanner scannerWithString:tempString];
			[intScanner setCharactersToBeSkipped:[[NSCharacterSet decimalDigitCharacterSet] invertedSet]];
			[intScanner scanInt:&runtime];
			
			if (runtime > 0) {
				[resultsDict setValue:[NSString stringWithFormat:@"%d", runtime] forKey:@"duration"];
			}
		}
		else {
			[searchScanner setScanLocation:0];
		}
		
		tempString = nil;
		[searchScanner scanUpToString:@"Country:</h5>" intoString:nil];
		// [searchScanner scanUpToString:@"\">" intoString:nil];
		[searchScanner scanUpToString:@"</div" intoString:&tempString];
		if ([tempString hasPrefix:@"Country:</h5>"]) {
			tempString = [[tempString substringFromIndex:13] stringByCleaningHTML];
			NSMutableString *aMutableString = [NSMutableString stringWithString:tempString];
			[aMutableString replaceOccurrencesOfString:@"\r" withString:@"" options:NSLiteralSearch range:NSMakeRange(0, [aMutableString length])];
			[aMutableString replaceOccurrencesOfString:@"\n" withString:@"" options:NSLiteralSearch range:NSMakeRange(0, [aMutableString length])];
			[aMutableString replaceOccurrencesOfString:@" | " withString:@", " options:NSLiteralSearch range:NSMakeRange(0, [aMutableString length])];
			[resultsDict setValue:aMutableString  forKey:@"country"];
		}	
		else {
			[searchScanner setScanLocation:0];
		}
		
		tempString = nil;
		[searchScanner scanUpToString:@"Language:</h5>" intoString:nil];
		// [searchScanner scanUpToString:@"\">" intoString:nil];
		[searchScanner scanUpToString:@"</div" intoString:&tempString];
		if ([tempString hasPrefix:@"Language:</h5>"]) {
			tempString = [[tempString substringFromIndex:14] stringByCleaningHTML];
			NSMutableString *aMutableString = [NSMutableString stringWithString:tempString];
			[aMutableString replaceOccurrencesOfString:@"\r" withString:@"" options:NSLiteralSearch range:NSMakeRange(0, [aMutableString length])];
			[aMutableString replaceOccurrencesOfString:@"\n" withString:@"" options:NSLiteralSearch range:NSMakeRange(0, [aMutableString length])];
			[aMutableString replaceOccurrencesOfString:@" | " withString:@", " options:NSLiteralSearch range:NSMakeRange(0, [aMutableString length])];
			[resultsDict setValue:aMutableString  forKey:@"languages"];
		}	
		else {
			[searchScanner setScanLocation:0];
		}
		
		tempString = nil;
		[searchScanner scanUpToString:@"Aspect Ratio:</h5>" intoString:nil];
		[searchScanner scanUpToString:@">" intoString:nil];
		[searchScanner scanUpToString:@"</" intoString:&tempString];
		if ([tempString hasPrefix:@">"]) {
			tempString = [tempString substringFromIndex:1];
			NSInteger location = [tempString rangeOfString:@"<a "].location;
			if (location != NSNotFound)
				tempString = [tempString substringToIndex:location];
			[resultsDict setValue:[tempString stringByCleaningHTML] forKey:@"aspectRatio"];
		}	
		else {
			[searchScanner setScanLocation:0];
		}
		
		tempString = nil;
		[searchScanner scanUpToString:@"Sound Mix:</h5>" intoString:nil];
		[searchScanner scanUpToString:@"\">" intoString:nil];
		[searchScanner scanUpToString:@"</" intoString:&tempString];
		if ([tempString hasPrefix:@"\">"]) {
			[resultsDict setValue:[[tempString substringFromIndex:2] stringByCleaningHTML] forKey:@"sound"];
		}	
		else {
			[searchScanner setScanLocation:0];
		}
		
		tempString = nil;
		[searchScanner scanUpToString:@"Company:</h5>" intoString:nil];
		[searchScanner scanUpToString:@">" intoString:nil];
		[searchScanner scanUpToString:@"</" intoString:&tempString];
		if ([tempString hasPrefix:@">"]) {
			[resultsDict setValue:[[tempString substringFromIndex:1] stringByCleaningHTML] forKey:@"studio"];
		}	
		else {
			[searchScanner setScanLocation:0];
		}
		
		
		// Parse the fulll credits page
		
		if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCredits"] boolValue]) {
			//full details Page
			NSURLRequest *theFullCastRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://imdb.com/title/tt%@/fullcredits", imdbNumber]] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:15.0];
			
			NSString *fullCreditResults = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:theFullCastRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
			
			if (fullCreditResults != nil) {
				
				NSScanner *fullCreditsScanner = [NSScanner scannerWithString:fullCreditResults];
				
				
				// Scan Actors
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsActors"] boolValue]) {
					[creditsArray removeAllObjects];
					NSString *creditsSection = @"";
					
					[fullCreditsScanner scanUpToString:@"table class=\"cast\"" intoString:nil];
					if ([fullCreditsScanner isAtEnd]) {
						[fullCreditsScanner setScanLocation:0];
						[fullCreditsScanner scanUpToString:@"Glossary/C#cast\">" intoString:nil];
					}
					
					//For series they don't have the glossary link
					if ([fullCreditsScanner isAtEnd]) {
						[fullCreditsScanner setScanLocation:0];
						[fullCreditsScanner scanUpToString:@">Series Cast</" intoString:nil];
					}
					
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&creditsSection];
					
					//if creditsSection is still empty then reset scan location otherwise get credits
					if (![creditsSection isEqualToString:@""]) {	   
						[self addCreditsFromSection:creditsSection to:resultsDict];
					}
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				
				// directors
				tempString = nil;
				[fullCreditsScanner setScanLocation:0];
				[fullCreditsScanner scanUpToString:@"Glossary/D#director\">" intoString:nil];
				[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
				
				if (tempString) {
					
					NSScanner *scanTemp;
					
					scanTemp = [NSScanner scannerWithString:tempString];
					[scanTemp scanUpToString:@"name/" intoString:nil];
					[scanTemp scanUpToString:@"/\">" intoString:nil];
					
					NSMutableArray *writerArray = [NSMutableArray array];
					
					while (![scanTemp isAtEnd]){
						NSString *tempStringTwo = @"";
						[scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
						[scanTemp scanUpToString:@"name/" intoString:nil];
						[scanTemp scanUpToString:@"/\">" intoString:nil];
						
						
						if ([tempStringTwo hasPrefix:@"/\">"]) {
							tempStringTwo = [tempStringTwo substringFromIndex:3];
						}
						
						if (![writerArray containsObject:tempStringTwo])
							[writerArray addObject:tempStringTwo];
					}
					
					if ([writerArray count])
						[resultsDict setValue:[[writerArray componentsJoinedByString:@", "] stringByCleaningHTML] forKey:@"director"];
				}
				else {
					[fullCreditsScanner setScanLocation:0];
				}
				
				
				// writers
				tempString = nil;
				[fullCreditsScanner setScanLocation:0];
				[fullCreditsScanner scanUpToString:@"Glossary/W#writer\">" intoString:nil];
				[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
				
				if (tempString) {
					
					NSScanner *scanTemp;
					
					scanTemp = [NSScanner scannerWithString:tempString];
					[scanTemp scanUpToString:@"name/" intoString:nil];
					[scanTemp scanUpToString:@"/\">" intoString:nil];
					
					NSMutableArray *writerArray = [NSMutableArray array];
					
					while (![scanTemp isAtEnd]){
						NSString *tempStringTwo = @"";
						[scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
						[scanTemp scanUpToString:@"name/" intoString:nil];
						[scanTemp scanUpToString:@"/\">" intoString:nil];
						
						
						if ([tempStringTwo hasPrefix:@"/\">"]) {
							tempStringTwo = [tempStringTwo substringFromIndex:3];
						}
						
						if (![writerArray containsObject:tempStringTwo])
							[writerArray addObject:tempStringTwo];
					}
					
					if ([writerArray count])
						[resultsDict setValue:[[writerArray componentsJoinedByString:@", "] stringByCleaningHTML] forKey:@"writer"];
				}
				else {
					[fullCreditsScanner setScanLocation:0];
				}
				
				
				// producers
				tempString = nil;
				[fullCreditsScanner setScanLocation:0];
				[fullCreditsScanner scanUpToString:@"Glossary/P#producer\">" intoString:nil];
				[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
				
				if (tempString) {
					
					NSScanner *scanTemp;
					
					scanTemp = [NSScanner scannerWithString:tempString];
					[scanTemp scanUpToString:@"name/" intoString:nil];
					[scanTemp scanUpToString:@"/\">" intoString:nil];
					
					NSMutableArray *writerArray = [NSMutableArray array];
					
					while (![scanTemp isAtEnd] && [writerArray count] < 4){
						NSString *tempStringTwo = @"";
						[scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
						[scanTemp scanUpToString:@"name/" intoString:nil];
						[scanTemp scanUpToString:@"/\">" intoString:nil];
						
						
						if ([tempStringTwo hasPrefix:@"/\">"]) {
							tempStringTwo = [tempStringTwo substringFromIndex:3];
						}
						
						if (![writerArray containsObject:tempStringTwo])
							[writerArray addObject:tempStringTwo];
					}
					
					if ([writerArray count])
						[resultsDict setValue:[[writerArray componentsJoinedByString:@", "] stringByCleaningHTML] forKey:@"producer"];
				}
				else {
					[fullCreditsScanner setScanLocation:0];
				}
				
				//The first three producers are placed in the produced by field, don't add them to credits
				/*
				 //add Producded by
				 if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsProducedBy"] boolValue]) {
				 tempString = nil;
				 [fullCreditsScanner setScanLocation:0];
				 [fullCreditsScanner scanUpToString:@"Glossary/P#producer\">" intoString:nil];
				 [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
				 if (tempString)
				 [self addCreditsFromSection:tempString to:resultsDict];
				 else
				 [fullCreditsScanner setScanLocation:0];
				 }
				 */
				
				//add original Music
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsMusic"] boolValue]) {
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/C#composer\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString withRole:@"Composer" to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				
				//add cinematographer
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsCinematographer"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/C#cinematographer\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString withRole:@"Cinematographer" to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				//add editor
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsEditor"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/E#editor\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString withRole:@"Editor" to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				//add Casting
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsCasting"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/C#casting_director\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString withRole:@"Casting Director" to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				
				//add production designer
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsProductionDesigner"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/P#production_designer\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString withRole:@"Production Designer" to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				
				
				//add Art Director
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsArtDirector"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/A#art_director\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString withRole:@"Art Director" to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				
				
				//add Set Decorator
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsSet"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/S#set_decorator\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString withRole:@"Set Decorator" to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				//add Custom Designers
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsCostume"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/C#costume_designer\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString withRole:@"Custome Designer" to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				
				//very long ones
				
				
				//add make_up_department 
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsMakeUp"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/M#make-up\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				//add  production_manager  
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsProductionManager"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/P#production_manager\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				//add assistant_director  
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsAssistant"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/A#assistant_director\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				
				//add art_department
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsArt"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/A#art_department\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				//add sound department
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsSound"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/S#sound_crew\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];	
				}
				
				
				//Special Effects
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsSpecial"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/S#special_effects\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				//Visual Effects
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsVisual"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/V#visual_effects\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];		
				}
				
				//add Stunts
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsStunts"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/S#stunt_performer\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
				//add Camera and Electrical http://www.imdb.com/Glossary/C#camera_department
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsElectrical"] boolValue]) {
					
					tempString = nil;
					[fullCreditsScanner scanUpToString:@"Glossary/C#camera_department\">" intoString:nil];
					[fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
					if (tempString)
						[self addCreditsFromSection:tempString to:resultsDict];
					else
						[fullCreditsScanner setScanLocation:0];
				}
				
			}
		}
		
		
		// :ToIn:20090409 
		//Add additional informations			
		//Add Plot Keywords
		if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBAdditionalPlotKeywords"] boolValue]) {
			
			//full plot keywords page
			NSURLRequest *theFullKeywordsRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://imdb.com/title/tt%@/keywords", imdbNumber]] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:15.0];
			NSString *fullKeywordsResults = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:theFullKeywordsRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
			
			if (fullKeywordsResults != nil) {
				
				NSScanner *fullKeywordsScanner = [NSScanner scannerWithString:fullKeywordsResults];
				tempString = nil;
				
				//Find the content block
				[fullKeywordsScanner scanUpToString:@"<div id=\"tn15content\">" intoString:nil];
				
				//Find the beginning of the list
				[fullKeywordsScanner scanUpToString:@"<ul>" intoString:nil];
				
				//Find the end of the list
				[fullKeywordsScanner scanUpToString:@"</ul>" intoString:&tempString];
				
				//A match?
				if (tempString)
					[self addAdditionalPlotKeywordsFromSection:tempString to:resultsDict];
				else
					[fullKeywordsScanner setScanLocation:0]; //not required a.t.m.
				
			}
		}	
		
		
		
		//If the arrays are empty remove them
		if ([creditsArray count] == 0) {
			[resultsDict removeObjectForKey:@"credits"];
		}
		
		
		
		//dvd Details Page
		theRequest=[NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://imdb.com/title/tt%@/dvd", imdbNumber]] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:30.0];
		
		NSString *imdbResults = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:theRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
		
		if (imdbResults != nil) {
			
			searchScanner = [NSScanner scannerWithString:imdbResults];
			
			//get a movie result that is not a box set by getting the section and looking for "titles in this product" not present
			NSString *possibleMovie = nil;
			[searchScanner scanUpToString:@"\"dvd_section\"" intoString:nil];	
			
			while (![searchScanner isAtEnd] && possibleMovie == nil) {
				[searchScanner scanUpToString:@"section\"" intoString:nil];	
				[searchScanner scanUpToString:@"\"dvd_section\"" intoString:&possibleMovie];	
				
				if ([possibleMovie rangeOfString:@"Titles in this Product"].location != NSNotFound)
					possibleMovie = nil;
			}
			
			if (possibleMovie != nil) {
				searchScanner = [NSScanner scannerWithString:possibleMovie];
				
				
				
				if ([resultsDict objectForKey:@"rated"] == nil) {
					[searchScanner scanUpToString:@"alt=\"Rating: " intoString:nil];	   
					if (![searchScanner isAtEnd]) {
						[searchScanner setScanLocation:[searchScanner scanLocation] +13];
						tempString = nil;
						[searchScanner scanUpToString:@"\"" intoString:&tempString];
						[resultsDict setValue:tempString forKey:@"rated"];
					}
				}
				
				if ([resultsDict objectForKey:@"duration"] == nil) {
					[searchScanner setScanLocation:0];
					[searchScanner scanUpToString:@">Runtime:</b>" intoString:nil];	   
					if (![searchScanner isAtEnd]) {
						[searchScanner setScanLocation:[searchScanner scanLocation] +13];
						int runningTime = 0;
						[searchScanner scanInt:&runningTime];
						
						if (runningTime > 0)
							[resultsDict setValue:[NSString stringWithFormat:@"%d", runningTime] forKey:@"duration"];
					}
				}
				
				// Getting company from the main page instead
				if ([resultsDict objectForKey:@"studio"] == nil) {	
					[searchScanner setScanLocation:0];
					[searchScanner scanUpToString:@">Studio:</b> " intoString:nil];	   
					if (![searchScanner isAtEnd]) {
						[searchScanner setScanLocation:[searchScanner scanLocation] +13];
						tempString = nil;
						[searchScanner scanUpToString:@"</" intoString:&tempString];
						[resultsDict setValue:[tempString stringByCleaningHTML] forKey:@"studio"];
					}
				}
				
				
				[searchScanner setScanLocation:0];
				[searchScanner scanUpToString:@">Release Date:</b> " intoString:nil];	   
				if (![searchScanner isAtEnd]) {
					[searchScanner setScanLocation:[searchScanner scanLocation] +19];
					tempString = nil;
					[searchScanner scanUpToString:@"<" intoString:&tempString];
					if ([tempString length] == 10) {  // YYYY-MM-DD;
						NSDate *theDate =[NSDate dateWithString:[NSString stringWithFormat:@"%@ 1:00:00 +0000", tempString]];
						if (theDate)
							[resultsDict setValue:theDate forKey:@"releaseDate"];
					}
				}
				
				[searchScanner setScanLocation:0];
				[searchScanner scanUpToString:@">DVD Format:</b>" intoString:nil];	   
				if (![searchScanner isAtEnd]) {
					[searchScanner setScanLocation:[searchScanner scanLocation] +16];
					tempString = nil;
					[searchScanner scanUpToString:@"<" intoString:&tempString];
					
					if ([tempString rangeOfString:@"Widescreen Anamorphic"].location != NSNotFound)
						[resultsDict setObject:@"Anamorphic Widescreen" forKey:@"pictureFormat"];
					else if ([tempString rangeOfString:@"Pan &amp; Scan"].location != NSNotFound)
						[resultsDict setObject:@"Pan & Scan" forKey:@"pictureFormat"];
					else if ([tempString rangeOfString:@"LetterBox"].location != NSNotFound)
						[resultsDict setObject:@"LetterBox" forKey:@"pictureFormat"];
					else if ([tempString rangeOfString:@"Academy Ratio"].location != NSNotFound)
						[resultsDict setObject:@"Academy Ratio" forKey:@"pictureFormat"];
					else if ([tempString rangeOfString:@"Video"].location != NSNotFound)
						[resultsDict setObject:@"Video" forKey:@"pictureFormat"];
					else if ([tempString rangeOfString:@"Widescreen"].location != NSNotFound)
						[resultsDict setObject:@"Widescreen" forKey:@"pictureFormat"];
					
					
					if ([tempString rangeOfString:@"2.35:1"].location != NSNotFound)
						[resultsDict setObject:@"2.35:1" forKey:@"aspectRatio"];
					else if ([tempString rangeOfString:@"1.33:1"].location != NSNotFound)
						[resultsDict setObject:@"1.33:1" forKey:@"aspectRatio"];
					else if ([tempString rangeOfString:@"1.78:1"].location != NSNotFound)
						[resultsDict setObject:@"1.78:1" forKey:@"aspectRatio"];
					else if ([tempString rangeOfString:@"1.66:1"].location != NSNotFound)
						[resultsDict setObject:@"1.66:1" forKey:@"aspectRatio"];
					else if ([tempString rangeOfString:@"1.85:1"].location != NSNotFound)
						[resultsDict setObject:@"1.85:1" forKey:@"aspectRatio"];
				}
				
				
				[searchScanner setScanLocation:0];
				[searchScanner scanUpToString:@">DVD Features: </b>" intoString:nil];	   
				if (![searchScanner isAtEnd]) {
					[searchScanner setScanLocation:[searchScanner scanLocation] +19];
					tempString = nil;
					[searchScanner scanUpToString:@"<" intoString:&tempString];
					
					NSString *internalTempString = nil;
					NSScanner *internalScanner = [NSScanner scannerWithString:tempString];
					[internalScanner scanUpToString:@"Subtitles: " intoString:nil];	  
					[internalScanner scanUpToString:@"Audio" intoString:&internalTempString];
					if ([internalTempString hasPrefix:@"Subtitles: "]) {
						internalTempString = [internalTempString substringFromIndex:11];
						
						if ([internalTempString hasSuffix:@", "])
							internalTempString = [internalTempString substringToIndex:[internalTempString length] - 2];
						
						[resultsDict setValue:[internalTempString stringByCleaningHTML] forKey:@"subtitles"];
					}
					
					NSMutableString *audio = [NSMutableString string];
					[internalScanner setScanLocation:0];
					while (![internalScanner isAtEnd]) {
						internalTempString = nil;
						[internalScanner scanUpToString:@"Audio Track" intoString:nil];	  
						[internalScanner scanUpToString:@": " intoString:nil];	  
						[internalScanner scanUpToString:@"Audio" intoString:&internalTempString];
						if ([internalTempString hasPrefix:@": "]) {
							NSMutableString *cleanAudio = [NSMutableString stringWithString:[internalTempString substringFromIndex:2]];
							
							
							if ([cleanAudio hasSuffix:@", Unknown, "])
								[cleanAudio deleteCharactersInRange:NSMakeRange([cleanAudio length] - 11, 11)];
							
							if ([internalTempString hasSuffix:@", "])
								[cleanAudio deleteCharactersInRange:NSMakeRange([cleanAudio length] - 2, 2)];
							
							[cleanAudio replaceOccurrencesOfString:@", " withString:@" " options:NSLiteralSearch range:NSMakeRange(0, [cleanAudio length])];
							
							if ([audio length] > 0)
								[audio appendString:@", "];
							
							[audio appendString:cleanAudio];
						}
						
					}
					
					if ([audio length] > 0) {
						[resultsDict setValue:audio forKey:@"languages"];
						
						if ([audio rangeOfString:@"THX"].location != NSNotFound)
							[resultsDict setObject:@"THX" forKey:@"sound"];
						if ([audio rangeOfString:@"Dolby Digital 5.1"].location != NSNotFound)
							[resultsDict setObject:@"Dolby Digital 5.1" forKey:@"sound"];
						else if ([audio rangeOfString:@"DTS"].location != NSNotFound)
							[resultsDict setObject:@"DTS" forKey:@"sound"];
						else if ([audio rangeOfString:@"Dolby Digital 2.1"].location != NSNotFound)
							[resultsDict setObject:@"Dolby Digital 2.1" forKey:@"sound"];
						else if ([audio rangeOfString:@"Dolby Digital 2.0 Stereo"].location != NSNotFound)
							[resultsDict setObject:@"Dolby Digital 2.0 Stereo" forKey:@"sound"];
						else if ([audio rangeOfString:@"Dolby Digital 2.0 Surround"].location != NSNotFound)
							[resultsDict setObject:@"Dolby Digital 2.0 Surround" forKey:@"sound"];
						else if ([audio rangeOfString:@"Dolby Digital 2.0 Mono"].location != NSNotFound)
							[resultsDict setObject:@"Dolby Digital 2.0 Mono" forKey:@"sound"];
						else if ([audio rangeOfString:@"Dolby Digital 2.0"].location != NSNotFound)
							[resultsDict setObject:@"Dolby Digital 2.0" forKey:@"sound"];
						
					}
				}
				
				
				//Possible region add
				
				
				// pick the us one
				[searchScanner setScanLocation:0];
				[searchScanner scanUpToString:@"=\"/ra/us/a/" intoString:nil];	   
				if (![searchScanner isAtEnd]) {
					tempString = nil;
					[searchScanner setScanLocation:[searchScanner scanLocation] +11];
					[searchScanner scanUpToString:@"\"" intoString:&tempString];
					
					[resultsDict setValue:tempString forKey:@"asin"];
					[self amazonImageForAsin:tempString toImageArray:imageLocationArray];
				}
				else {
					
					//  Try to match the titles
					BOOL titleMatch = NO;
					NSArray *titleAndAsin = [imdbResults stringsBetween:@"\"><h3>" and:@"dvd_section\""];
					NSEnumerator *dvdsEnum = [titleAndAsin objectEnumerator];
					NSString *nextDVD;
					while (nextDVD = [dvdsEnum nextObject]) {
						int loc = [nextDVD rangeOfString:@"</h3>"].location;
						if (loc == NSNotFound)
							continue;
						NSString *title = [nextDVD substringToIndex:loc];
						NSString *asin = [nextDVD stringBetween:@">ASIN:</b> " and:@"<"];
						title = [title stringByCleaningHTML];
						
						if (title && asin && [title rangeOfString:movieTitle options:NSCaseInsensitiveSearch].location != NSNotFound) {
							[resultsDict setValue:asin forKey:@"asin"];
							[self amazonImageForAsin:asin toImageArray:imageLocationArray];
							titleMatch = YES;
							break;
						}
					}
					
					
					// pick the first one
					if (titleMatch == NO) {
						
						[searchScanner setScanLocation:0];
						[searchScanner scanUpToString:@">ASIN:</b> " intoString:nil];	   
						if (![searchScanner isAtEnd]) {
							tempString = nil;
							[searchScanner setScanLocation:[searchScanner scanLocation] +11];
							[searchScanner scanUpToString:@"<" intoString:&tempString];
							
							[resultsDict setValue:tempString forKey:@"asin"];
							[self amazonImageForAsin:tempString toImageArray:imageLocationArray];
						}
					}
					 
				}
				
				[searchScanner setScanLocation:0];
				[searchScanner scanUpToString:@">UPC:</b> " intoString:nil];	   
				if (![searchScanner isAtEnd]) {
					[searchScanner setScanLocation:[searchScanner scanLocation] +10];
					tempString = nil;
					[searchScanner scanUpToString:@"<" intoString:&tempString];
					[resultsDict setValue:tempString forKey:@"upc"];
				}
				
				
				
				
				[searchScanner setScanLocation:0];
				[searchScanner scanUpToString:@">Supplements<" intoString:nil];	   
				if (![searchScanner isAtEnd]) {
					tempString = nil;
					[searchScanner scanUpToString:@"<hr />" intoString:&tempString];
					
					NSString *internalTempString = nil;
					NSScanner *internalScanner = [NSScanner scannerWithString:tempString];
					
					[internalScanner scanUpToString:@"Subtitles: " intoString:nil];	  
					[internalScanner scanUpToString:@"Audio" intoString:&internalTempString];
					if ([internalTempString hasPrefix:@"Subtitles: "]) {
						internalTempString = [internalTempString substringFromIndex:11];
						
						if ([internalTempString hasSuffix:@", "])
							internalTempString = [internalTempString substringToIndex:[internalTempString length] - 2];
						
						[resultsDict setValue:[internalTempString stringByCleaningHTML] forKey:@"subtitles"];
					}
					
					NSMutableString *audio = [NSMutableString string];
					[internalScanner setScanLocation:0];
					while (![internalScanner isAtEnd]) {
						internalTempString = nil;
						[internalScanner scanUpToString:@"<div class=\"dvd_row_alt\">" intoString:nil];	  
						[internalScanner scanUpToString:@"class" intoString:nil];	  
						[internalScanner scanUpToString:@"</div" intoString:&internalTempString];
						if ([internalTempString hasPrefix:@"class=\"dvd_row_alt\">"]) {
							internalTempString = [internalTempString substringFromIndex:20];
							
							if ([internalTempString hasPrefix:@"<b>Disc One: "])
								internalTempString = [internalTempString substringFromIndex:13];
							else if ([internalTempString hasPrefix:@"<b>Disc Two: "])
								internalTempString = [internalTempString substringFromIndex:13];
							else if ([internalTempString hasPrefix:@"<b>Disc Three: "])
								internalTempString = [internalTempString substringFromIndex:15];
							else if ([internalTempString hasPrefix:@"<b>Disc Four: "])
								internalTempString = [internalTempString substringFromIndex:14];
							
							if ([audio length] > 0)
								[audio appendString:@"\n"];
							
							[audio appendString:internalTempString];
						}
						
					}
					
					if ([audio length] > 0) {
						[audio replaceOccurrencesOfString:@"<i>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
						[audio replaceOccurrencesOfString:@"</i>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
						[audio replaceOccurrencesOfString:@"<I>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
						[audio replaceOccurrencesOfString:@"</I>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
						[audio replaceOccurrencesOfString:@"</b>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
						[audio replaceOccurrencesOfString:@"<b>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
						
						[resultsDict setValue:[audio stringByCleaningHTML] forKey:@"features"];
					}
				}		
			}
		}
	}
	
	//[pool release];
	return resultsDict;	   
}

- (void)addCreditsFromSection:(NSString *)creditsSection to:(NSMutableDictionary *)resultsDict {
	
		NSScanner *scanTemp = [NSScanner scannerWithString:creditsSection];
		NSMutableArray *creditsArray = [resultsDict objectForKey:@"credits"];		
		
		while (![scanTemp isAtEnd]) {
			NSString *nameString = nil;
			NSString *rolesString = nil;
			
			[scanTemp scanUpToString:@"/name/nm" intoString:nil];
			[scanTemp scanUpToString:@"\">" intoString:nil];
			
			[scanTemp scanUpToString:@"<" intoString:&nameString];
			
			//Skip the headshot link
			while ([nameString isEqualToString:@"\">"] && ![scanTemp isAtEnd]) {		
				[scanTemp scanUpToString:@"\">" intoString:nil];
				[scanTemp scanUpToString:@"<" intoString:&nameString];
			}
			
			[scanTemp scanUpToString:@"\">" intoString:nil];
			[scanTemp scanUpToString:@"<" intoString:&rolesString];
			while (([rolesString isEqualToString:@"\">"] || [rolesString hasPrefix:@"\"> ..."]) && ![scanTemp isAtEnd]) {
				NSString *HTMLCodeInBetween = nil;
								
				[scanTemp scanUpToString:@"\">" intoString:nil];
				[scanTemp scanUpToString:@"<" intoString:&rolesString];
				NSInteger previousLocation = [scanTemp scanLocation];
				[scanTemp scanUpToString:@"\">" intoString:&HTMLCodeInBetween];

				//went to far to next name, move back to it, leave role empty
				NSInteger nameLocation = [HTMLCodeInBetween rangeOfString:@"\"/name/nm"].location;
				if (nameLocation != NSNotFound) {
					rolesString = @"\">";
					[scanTemp setScanLocation:previousLocation];
					break;
				}
			}
			
			/*
			 [scanTemp scanUpToString:@"\">" intoString:nil];
			 [scanTemp scanUpToString:@"<" intoString:nil];
			 
			 //scan to first name with IMDB link
			// Was changed from / to add a ; before that
			[scanTemp scanUpToString:@";\">" intoString:nil];
			[scanTemp scanUpToString:@"\">" intoString:nil];
			
			//Repeat until something that is not HTML code
			while ([nameString isEqualToString:@"\">"]  && ![scanTemp isAtEnd]) {
				[scanTemp scanUpToString:@"<" intoString:&nameString];
				[scanTemp scanUpToString:@"\">" intoString:nil];
			}
			
			//Find role by repeating
			NSString *HTMLCodeInBetween = nil;
			while (([rolesString isEqualToString:@"\">"] || ) && ![scanTemp isAtEnd]) {
				[scanTemp scanUpToString:@"<" intoString:&rolesString];
				[scanTemp scanUpToString:@"\">" intoString:&HTMLCodeInBetween];
				
				//went to far to next name, move back a bit and break
				if ([HTMLCodeInBetween rangeOfString:@"\"/name/nm"].location != NSNotFound) {
					rolesString = @"\">";
					[scanTemp setScanLocation:[scanTemp scanLocation] - 3];
					break;
				}
			}
			*/
			
			if ([nameString hasPrefix:@"\">"] && [rolesString hasPrefix:@"\">"] && [nameString length] > 2) {
				nameString = [[nameString substringFromIndex:2] stringByCleaningHTML];
				rolesString = [[rolesString substringFromIndex:2] stringByCleaningHTML];
				if ([rolesString length] == 0)
					rolesString = nil;
				
				//make sure role does not say uncredited don't add uncredited
				if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsUncredited"] boolValue] || (rolesString && [rolesString rangeOfString:@"(uncredited)"].location == NSNotFound)) {
					[creditsArray addObject:[NSDictionary dictionaryWithObjectsAndKeys:nameString, @"name", rolesString, @"role", nil]];
				}
			}
			
			
		}
}

/*
 
 //Repeat until something that not HTML code and not the .... of separation

 
 */

- (void)addCreditsFromSection:(NSString *)creditsSection withRole:(NSString *)aRole to:(NSMutableDictionary *)resultsDict {
			
		NSScanner *scanTemp = [NSScanner scannerWithString:creditsSection];
		NSMutableArray *creditsArray = [resultsDict objectForKey:@"credits"];
	
		id fieldsController = [[NSApp delegate] fieldsController];

		while (![scanTemp isAtEnd]) {
			NSString *nameString = @"\">";
			
			//scan to first name with IMDB link
			[scanTemp scanUpToString:@"/\">" intoString:nil];
			[scanTemp scanUpToString:@"\">" intoString:nil];
			
			//Repeat until something that not HTML code
			while ([nameString isEqualToString:@"\">"] && ![scanTemp isAtEnd]) {
				[scanTemp scanUpToString:@"<" intoString:&nameString];
				[scanTemp scanUpToString:@"\">" intoString:nil];
			}
			
					
			if ([nameString hasPrefix:@"\">"] && [nameString length] > 2) {
				nameString = [[nameString substringFromIndex:2] stringByCleaningHTML];
				[creditsArray addObject:[NSDictionary dictionaryWithObjectsAndKeys:nameString, @"name", aRole, @"role", nil]];
				
				if (aRole) {
					NSString *customField = [fieldsController customFieldWithTitle:aRole];
					if (customField) {
						NSString *previousEntry = [resultsDict valueForKey:customField];
						if (previousEntry) 
							nameString = [previousEntry stringByAppendingFormat:@", %@", nameString];
						[resultsDict setValue:nameString forKey:customField];
					}
				}
				
				
				/*
				if ([aRole isEqualToString:@"Composer"])
					[resultsDict setValue:nameString forKey:@"custom1"];
				else if ([aRole isEqualToString:@"Cinematographer"])
					[resultsDict setValue:nameString forKey:@"custom2"];
				 */
				 
			}
		}
}

// :ToIn:20090409 
- (void)addAdditionalPlotKeywordsFromSection:(NSString *)plotKeywordsSection to:(NSMutableDictionary *)resultsDict {
	
	//Some allocations
	NSString *myChain = @"";
	NSString *tmp;
	BOOL die = NO;
	
	//Isn't it pretty freaky to do somethink like that without regular expressions?
	NSScanner *scanTemp = [NSScanner scannerWithString:plotKeywordsSection];
	
	//Oh baby, let's loop again
	while (!die) {
		
		//Reset the tmp string
		tmp = nil;
		
		//This will help us
		NSString *startString = @"/\">";
		NSString *endString = @"</a>";
		
		//Find the next keyword
		[scanTemp scanUpToString:startString intoString:nil];
		[scanTemp scanUpToString:endString intoString:&tmp];
		
		//Do we have one?
		if( tmp != nil ) 
			myChain = [myChain stringByAppendingFormat:@", %@", [[tmp stringByCleaningHTML] substringFromIndex:[startString length]]];
		else 
			die = YES;
		
	}
	
	//If the have something in myChain, it will allways starts with a leading ",". We don't need it!
	if( [myChain length] != 0 ) 
		[resultsDict setObject:[myChain substringFromIndex:2] forKey:@"tags"];	
	
}


- (void)amazonImageForAsin:(NSString *)anAsin toImageArray:(NSMutableArray *)anArray {		
	//US
	NSString *possibleURL = [NSString stringWithFormat:@"http://images.amazon.com/images/P/%@.01.LZZZZZZZ.jpg", anAsin];
	[anArray insertObject:possibleURL atIndex:0];
	
	//UK
	possibleURL = [NSString stringWithFormat:@"http://images-eu.amazon.com/images/P/%@.02.LZZZZZZZ.jpg", anAsin];
	[anArray insertObject:possibleURL atIndex:0];
	
	//DE
	possibleURL = [NSString stringWithFormat:@"http://images-eu.amazon.com/images/P/%@.03.LZZZZZZZ.jpg", anAsin];
	[anArray insertObject:possibleURL atIndex:0];
	
}


- (NSArray *)resultsTitles {
	return resultsTitle;
}


- (NSMutableDictionary *)oldIMDBParsingStyle:(NSString *)aString imdbNumber:(NSString *)imdbNumber {
	NSMutableDictionary *resultsDict = [NSMutableDictionary dictionary];
	
	NSMutableString *imdbResults = [NSMutableString stringWithString:aString]; 
	NSScanner *searchScanner;
	while (YES) {
		int tempInt = 0;
		searchScanner = [NSScanner scannerWithString:imdbResults];
		[searchScanner scanUpToString:@"&#" intoString:nil];
		if ([searchScanner isAtEnd])
			break;
		[searchScanner setScanLocation:[searchScanner scanLocation] +2];
		[searchScanner scanInt:&tempInt];
		
		if (tempInt)
			[imdbResults replaceOccurrencesOfString:[NSString stringWithFormat:@"&#%d;", tempInt] withString:[NSString stringWithFormat:@"%C", tempInt]  options:NSLiteralSearch range:NSMakeRange(0, [imdbResults length])];
		else 
			[imdbResults deleteCharactersInRange:NSMakeRange([searchScanner scanLocation] -2,2)];
		//delete error &# that should not exist;
	}
	
	
	searchScanner = [NSScanner scannerWithString:imdbResults];
	
	[resultsDict setValue:imdbNumber forKey:@"imdb"];
	NSMutableArray *imageLocationArray = [NSMutableArray array];
	[resultsDict setObject:imageLocationArray forKey:@"imageLocationArray"];
	
	NSString *tempString = nil;
	[searchScanner scanUpToString:@"class=\"title\">" intoString:nil];
	[searchScanner scanUpToString:@"<" intoString:&tempString];
	
	if ([tempString hasPrefix:@"class=\"title\">"]) {
		NSMutableString *cleanString = [NSMutableString string];
		[cleanString setString:[tempString substringWithRange:NSMakeRange(14, [tempString length] - 15)]];
		[cleanString replaceOccurrencesOfString:@"\n" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[cleanString length])];
		
		[resultsDict setValue:cleanString forKey:@"title"];
	}
	else {
		[searchScanner setScanLocation:0];
	}
	
	tempString = nil;
	[searchScanner scanUpToString:@"Sections/Years/" intoString:nil];
	[searchScanner scanUpToString:@"\">" intoString:&tempString];
	
	if ([tempString hasPrefix:@"Sections/Years/"]) {
		NSDate *tempDate = [NSDate dateWithNaturalLanguageString:[tempString substringFromIndex:15] locale:nil];
		if (tempDate)
			[resultsDict setValue:tempDate forKey:@"theatrical"];
	}
	else {
		[searchScanner setScanLocation:0];
	}
	
	tempString = nil;
   [searchScanner scanUpToString:@"<img" intoString:nil];
   [searchScanner scanUpToString:@"http://ia.ec.imdb.com/media/" intoString:nil];
   [searchScanner scanUpToString:@"\"" intoString:&tempString];
   
   if ([tempString hasPrefix:@"http://ia.ec.imdb.com/media/"]) {
	   [imageLocationArray addObject:tempString];
   }

	
	tempString = nil;
	[searchScanner scanUpToString:@"Directed by" intoString:nil];
	[searchScanner scanUpToString:@"<b class=" intoString:&tempString];
	
	if (tempString) {
		NSScanner *scanTemp;
		
		scanTemp = [NSScanner scannerWithString:tempString];
		[scanTemp scanUpToString:@"/\">" intoString:nil];
		
		NSString *director = @"";
		
		if (![scanTemp isAtEnd])  {
			
			while (YES){
				NSString *tempStringTwo = @"";

				[scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
				[scanTemp scanUpToString:@"/\">" intoString:nil];
				
				if ([tempStringTwo hasPrefix:@"/\">"]) {
					tempStringTwo = [tempStringTwo substringFromIndex:3];
				}
				
				if ([scanTemp isAtEnd]) {
					director = [NSString stringWithFormat:@"%@%@", director, tempStringTwo];
					break;
				}
				else {
					director = [NSString stringWithFormat:@"%@%@, ", director, tempStringTwo];
				}
			}
		}
		
		if (![director isEqualToString:@""])
			[resultsDict setValue:director forKey:@"director"];
	}
	else {
		[searchScanner setScanLocation:0];
	}
	
	tempString = nil;
    [searchScanner scanUpToString:@"Writing credits" intoString:nil];
	[searchScanner scanUpToString:@"</td>" intoString:&tempString];
	
	if (tempString) {
		
		NSScanner *scanTemp;
		
		scanTemp = [NSScanner scannerWithString:tempString];
		[scanTemp scanUpToString:@"/\">" intoString:nil];
		
		NSString *writer = @"";
		
		if (![scanTemp isAtEnd])  {
			
			while (YES){
				NSString *tempStringTwo = @"";
				[scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
				[scanTemp scanUpToString:@"/\">" intoString:nil];
				
				if ([tempStringTwo hasPrefix:@"/\">"]) {
					tempStringTwo = [tempStringTwo substringFromIndex:3];
				}
				
				if ([scanTemp isAtEnd]) {
					writer = [NSString stringWithFormat:@"%@%@", writer, tempStringTwo];
					break;
				}
				else {
					writer = [NSString stringWithFormat:@"%@%@, ", writer, tempStringTwo];
				}
			}
		}
		if (![writer isEqualToString:@""])
			[resultsDict setValue:writer forKey:@"writer"];
	}
	else {
		[searchScanner setScanLocation:0];
	}
	
	tempString = nil;
	[searchScanner scanUpToString:@"/Sections/Genres/" intoString:nil];
	[searchScanner scanUpToString:@"/\">" intoString:&tempString];
	if ([tempString hasPrefix:@"/Sections/Genres/"]) {
		[resultsDict setValue:[tempString substringFromIndex:17] forKey:@"genre"];
	}
	else {
		[searchScanner setScanLocation:0];
	}
	
	
	tempString = nil;
    [searchScanner scanUpToString:@"Tagline:</b>" intoString:nil];
	   [searchScanner scanUpToString:@"> " intoString:nil];
	   [searchScanner scanUpToString:@"<" intoString:&tempString];
	   if ([tempString hasPrefix:@"> "]) {
		   [resultsDict setValue:[tempString substringFromIndex:2] forKey:@"comments"];
	   }	
	   else {
		   [searchScanner setScanLocation:0];
	   }
	   
	   tempString = nil;
	   [searchScanner scanUpToString:@"Plot Outline:</b>" intoString:nil];
	   [searchScanner scanUpToString:@"> " intoString:nil];
	   [searchScanner scanUpToString:@"<" intoString:&tempString];
	   if ([tempString hasPrefix:@"> "]) {
		NSURLRequest *plotSummaryRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://imdb.com/title/tt%@/plotsummary", imdbNumber]] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:10.0];
		   
		   NSString *fullPlotSummary = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:plotSummaryRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
		   if (fullPlotSummary) {
			   fullPlotSummary = [fullPlotSummary stringBetween:@"plotpar\">" and:@"<"];
			   [resultsDict setValue:[fullPlotSummary stringByCleaningHTML] forKey:@"summary"];
		   }
		   else 
			   [resultsDict setValue:[[tempString substringFromIndex:1] stringByCleaningHTML] forKey:@"summary"];
	}	


	
	[searchScanner setScanLocation:0];
	tempString = nil;
	NSString *rating = nil;
	[searchScanner scanUpToString:@"<a href=\"/rg/title-tease/rating-stars/title" intoString:nil];
	[searchScanner scanUpToString:@"<b>" intoString:nil];
	[searchScanner scanUpToString:@"/" intoString:&tempString];
	if ([tempString hasPrefix:@"<b>"]) {
		rating = [tempString substringFromIndex:3];
		[searchScanner scanUpToString:@"(" intoString:nil];
		[searchScanner scanUpToString:@")" intoString:&tempString];
		rating = [NSString stringWithFormat:@"%@ %@)", rating, tempString];
		[resultsDict setValue:rating forKey:@"rating"];
	}	
	else {
		[searchScanner setScanLocation:0];
	}
	
	   
	
	   //Set arrays needed for roles and names
	   NSMutableArray *creditsArray = [NSMutableArray arrayWithCapacity:15];
	   [resultsDict setObject:creditsArray forKey:@"credits"];
	   
	   // Scan Actors
	   NSString *creditsSection = @"";
	   [searchScanner scanUpToString:@"<b class=\"blackcatheader\">" intoString:nil];
	   [searchScanner scanUpToString:@"</table>" intoString:&creditsSection];
	   
	   //if creditsSection is still empty then reset scan location otherwise get credits
	   if (![creditsSection isEqualToString:@""]) {	   
		   [self addCreditsFromSection:creditsSection to:resultsDict];
	   }
	   else
		   [searchScanner setScanLocation:0];
	   
	   
	    // Parse the fulll credits page
	   
	   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCredits"] boolValue]) {
		   //dvd Details Page
		   NSURLRequest *theFullCastRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://imdb.com/title/tt%@/fullcredits", imdbNumber]] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:15.0];
		   
		   NSString *fullCreditResults = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:theFullCastRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
		   
		   if (fullCreditResults != nil) {
		   
		   NSScanner *fullCreditsScanner = [NSScanner scannerWithString:fullCreditResults];
		   
			   
		   // Scan Actors
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsActors"] boolValue]) {
			   [creditsArray removeAllObjects];
			   NSString *creditsSection = @"";
			   
			   [fullCreditsScanner scanUpToString:@"Glossary/C#cast\">" intoString:nil];
			   
			   //For series they don't have the glossary link
			   if ([fullCreditsScanner isAtEnd]) {
				   [fullCreditsScanner setScanLocation:0];
				   [fullCreditsScanner scanUpToString:@"<h5>Series Cast</h5>" intoString:nil];
			   }
				   
			   [fullCreditsScanner scanUpToString:@"</table>" intoString:&creditsSection];
			   
			   //if creditsSection is still empty then reset scan location otherwise get credits
			   if (![creditsSection isEqualToString:@""]) {	   
				   [self addCreditsFromSection:creditsSection to:resultsDict];
			   }
			   else
				   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   // directors
		   tempString = nil;
		   [fullCreditsScanner setScanLocation:0];
		   [fullCreditsScanner scanUpToString:@"Glossary/D#director\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   
		   if (tempString) {
			   
			   NSScanner *scanTemp;
			   
			   scanTemp = [NSScanner scannerWithString:tempString];
			   [scanTemp scanUpToString:@"name/" intoString:nil];
			   [scanTemp scanUpToString:@"/\">" intoString:nil];
			   
			   NSMutableArray *writerArray = [NSMutableArray array];
			   
			   while (![scanTemp isAtEnd]){
				   NSString *tempStringTwo = @"";
				   [scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
				   [scanTemp scanUpToString:@"name/" intoString:nil];
				   [scanTemp scanUpToString:@"/\">" intoString:nil];
				   
				   
				   if ([tempStringTwo hasPrefix:@"/\">"]) {
					   tempStringTwo = [tempStringTwo substringFromIndex:3];
				   }
				   
				   if (![writerArray containsObject:tempStringTwo])
					   [writerArray addObject:tempStringTwo];
			   }
			   
			   if ([writerArray count])
				   [resultsDict setValue:[[writerArray componentsJoinedByString:@", "] stringByCleaningHTML] forKey:@"director"];
		   }
		   else {
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   // writers
		   tempString = nil;
		   [fullCreditsScanner setScanLocation:0];
		   [fullCreditsScanner scanUpToString:@"Glossary/W#writer\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   
		   if (tempString) {
			   
			   NSScanner *scanTemp;
			   
			   scanTemp = [NSScanner scannerWithString:tempString];
			   [scanTemp scanUpToString:@"name/" intoString:nil];
			   [scanTemp scanUpToString:@"/\">" intoString:nil];
			   
			   NSMutableArray *writerArray = [NSMutableArray array];
			   
			   while (![scanTemp isAtEnd]){
				   NSString *tempStringTwo = @"";
				   [scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
				   [scanTemp scanUpToString:@"name/" intoString:nil];
				   [scanTemp scanUpToString:@"/\">" intoString:nil];
				   
				   
				   if ([tempStringTwo hasPrefix:@"/\">"]) {
					   tempStringTwo = [tempStringTwo substringFromIndex:3];
				   }
				   
				   if (![writerArray containsObject:tempStringTwo])
					   [writerArray addObject:tempStringTwo];
			   }
			   
			   if ([writerArray count])
				   [resultsDict setValue:[[writerArray componentsJoinedByString:@", "] stringByCleaningHTML] forKey:@"writer"];
		   }
		   else {
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   // producers
		   tempString = nil;
		   [fullCreditsScanner setScanLocation:0];
		   [fullCreditsScanner scanUpToString:@"Glossary/P#producer\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   
		   if (tempString) {
			   
			   NSScanner *scanTemp;
			   
			   scanTemp = [NSScanner scannerWithString:tempString];
			   [scanTemp scanUpToString:@"name/" intoString:nil];
			   [scanTemp scanUpToString:@"/\">" intoString:nil];
			   
			   NSMutableArray *writerArray = [NSMutableArray array];
			   
			   while (![scanTemp isAtEnd] && [writerArray count] < 3){
				   NSString *tempStringTwo = @"";
				   [scanTemp scanUpToString:@"<" intoString:&tempStringTwo];
				   [scanTemp scanUpToString:@"name/" intoString:nil];
				   [scanTemp scanUpToString:@"/\">" intoString:nil];
				   
				   
				   if ([tempStringTwo hasPrefix:@"/\">"]) {
					   tempStringTwo = [tempStringTwo substringFromIndex:3];
				   }
				   
				   if (![writerArray containsObject:tempStringTwo])
					   [writerArray addObject:tempStringTwo];
			   }
			   
			   if ([writerArray count])
				   [resultsDict setValue:[[writerArray componentsJoinedByString:@", "] stringByCleaningHTML] forKey:@"producer"];
		   }
		   else {
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   //add Producded by
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsProducedBy"] boolValue]) {
			   tempString = nil;
			   [fullCreditsScanner scanUpToString:@"Glossary/P#producer\">" intoString:nil];
			   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
			   if (tempString)
				   [self addCreditsFromSection:tempString to:resultsDict];
			   else
				   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   //add original Music
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsMusic"] boolValue]) {
		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/C#composer\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString withRole:@"composer" to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   //add cinematographer
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsCinematographer"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/C#cinematographer\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString withRole:@"Cinematographer" to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   //add editor
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsEditor"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/E#editor\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString withRole:@"editor" to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   //add Casting
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsCasting"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/C#casting_director\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString withRole:@"Casting Director" to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   //add production designer
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsProductionDesigner"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/P#production_designer\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString withRole:@"Production Designer" to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }

		   
		   
		   //add Art Director
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsArtDirector"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/A#art_director\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString withRole:@"Art Director" to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   
		   //add Set Decorator
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsSet"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/S#set_decorator\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString withRole:@"Set Decorator" to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   //add Custom Designers
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsCostume"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/C#costume_designer\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString withRole:@"Custome Designer" to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   //very long ones
		   
		   
		   //add make_up_department 
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsMakeUp"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/M#make_up_department\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   //add  production_manager  
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsProductionManager"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/P#production_manager\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   //add assistant_director  
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsAssistant"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/A#assistant_director\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   
		   //add art_department
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsArt"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/A#art_department\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   //add sound department
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsSound"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/S#sound_department\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];	
		   }
			
		   
		   //Special Effects
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsSpecial"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/S#special_effects\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];
		   }
		   
		   //Visual Effects
		   if ([[[NSUserDefaults standardUserDefaults] objectForKey:@"IMDBCreditsVisual"] boolValue]) {

		   tempString = nil;
		   [fullCreditsScanner scanUpToString:@"Glossary/V#visual_effects\">" intoString:nil];
		   [fullCreditsScanner scanUpToString:@"</table>" intoString:&tempString];
		   if (tempString)
			   [self addCreditsFromSection:tempString to:resultsDict];
		   else
			   [fullCreditsScanner setScanLocation:0];		
		   }
		}
	   }
	   
	   
	   
	   //If the arrays are empty remove them
	   if ([creditsArray count] == 0) {
		   [resultsDict removeObjectForKey:@"credits"];
	   }
	   

	   
	   
	   
	   
	   
	   
	   tempString = nil;
	   [searchScanner scanUpToString:@"MPAA</a>:</b> Rated " intoString:nil];
	   [searchScanner scanUpToString:@"<br>" intoString:&tempString];
	   if ([tempString hasPrefix:@"MPAA</a>:</b> Rated "]) {
		   tempString = [tempString substringFromIndex:20];
		   
		   if ([tempString rangeOfString:@"PG-13"].location != NSNotFound) {
			   tempString = @"PG-13";
		   }
		   else if ([tempString rangeOfString:@"PG "].location != NSNotFound) {
			   tempString = @"PG";
		   }
		   else if ([tempString rangeOfString:@"G "].location != NSNotFound) {
			   tempString = @"G";
		   }
		   else if ([tempString rangeOfString:@"NC-17"].location != NSNotFound) {
			   tempString = @"NC-17";
		   }
		   else if ([tempString rangeOfString:@"NR "].location != NSNotFound) {
			   tempString = @"NR";
		   }
		   else if ([tempString rangeOfString:@"R "].location != NSNotFound) {
			   tempString = @"R";
		   }
		   
		   [resultsDict setValue:tempString forKey:@"rated"];
		   
	   }
	   else {
		   [searchScanner setScanLocation:0];
	   }
	   
	   tempString = nil;
	   [searchScanner scanUpToString:@"Runtime:</b>\n" intoString:nil];
	   [searchScanner scanUpToString:@"<br>" intoString:&tempString];
	   if ([tempString hasPrefix:@"Runtime:</b>\n"]) {
		   int runtime;
		   NSScanner *intScanner = [NSScanner scannerWithString:tempString];
		   [intScanner setCharactersToBeSkipped:[[NSCharacterSet decimalDigitCharacterSet] invertedSet]];
		   [intScanner scanInt:&runtime];
		   
		   if (runtime > 0) {
			   [resultsDict setValue:[NSString stringWithFormat:@"%d", runtime] forKey:@"duration"];
		   }
	   }
	   else {
		   [searchScanner setScanLocation:0];
	   }
	   
	   tempString = nil;
	   [searchScanner scanUpToString:@"Country:</b>" intoString:nil];
	   [searchScanner scanUpToString:@"\">" intoString:nil];
	   [searchScanner scanUpToString:@"<" intoString:&tempString];
	   if ([tempString hasPrefix:@"\">"]) {
		   [resultsDict setValue:[tempString substringFromIndex:2] forKey:@"country"];
	   }	
	   else {
		   [searchScanner setScanLocation:0];
	   }
	   
	   
	   //dvd Details Page
	   NSURLRequest *theRequest=[NSURLRequest requestWithURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://imdb.com/title/tt%@/dvd", imdbNumber]] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:30.0];
	   
	   imdbResults = [[[NSString alloc] initWithData:[NSURLConnection sendSynchronousRequest:theRequest returningResponse:nil error:nil] encoding:NSISOLatin1StringEncoding] autorelease];
	   
	   if (imdbResults == nil) {
		   return resultsDict;
	   }

	   
	   searchScanner = [NSScanner scannerWithString:imdbResults];
	   
	   if ([resultsDict objectForKey:@"rated"] == nil) {
		   [searchScanner scanUpToString:@"alt=\"Rating: " intoString:nil];	   
		   if (![searchScanner isAtEnd]) {
			   [searchScanner setScanLocation:[searchScanner scanLocation] +13];
			   tempString = nil;
			   [searchScanner scanUpToString:@"\"" intoString:&tempString];
			   [resultsDict setValue:tempString forKey:@"rated"];
		   }
	   }

	   if ([resultsDict objectForKey:@"duration"] == nil) {
	   [searchScanner setScanLocation:0];
	   [searchScanner scanUpToString:@">Runtime:</b>" intoString:nil];	   
	   if (![searchScanner isAtEnd]) {
		   [searchScanner setScanLocation:[searchScanner scanLocation] +13];
		   int runningTime = 0;
		   [searchScanner scanInt:&runningTime];
		   
		   if (runningTime > 0)
		   [resultsDict setValue:[NSString stringWithFormat:@"%d", runningTime] forKey:@"duration"];
	   }
	   }
	   
	   
	   [searchScanner setScanLocation:0];
	   [searchScanner scanUpToString:@">Studio:</b> " intoString:nil];	   
	   if (![searchScanner isAtEnd]) {
		   [searchScanner setScanLocation:[searchScanner scanLocation] +13];
		   tempString = nil;
		   [searchScanner scanUpToString:@"<" intoString:&tempString];
		   [resultsDict setValue:tempString forKey:@"studio"];
	   }
	   
	   
	   [searchScanner setScanLocation:0];
	   [searchScanner scanUpToString:@">Release Date:</b> " intoString:nil];	   
	   if (![searchScanner isAtEnd]) {
		   [searchScanner setScanLocation:[searchScanner scanLocation] +19];
		   tempString = nil;
		   [searchScanner scanUpToString:@"<" intoString:&tempString];
		   if ([tempString length] == 10) {  // YYYY-MM-DD;
		   NSDate *theDate =[NSDate dateWithString:[NSString stringWithFormat:@"%@ 10:45:32 +0600", tempString]];
		   if (theDate)
			   [resultsDict setValue:theDate forKey:@"releaseDate"];
		   }
	   }
	   
	   [searchScanner setScanLocation:0];
	   [searchScanner scanUpToString:@">DVD Format:</b>" intoString:nil];	   
	   if (![searchScanner isAtEnd]) {
		   [searchScanner setScanLocation:[searchScanner scanLocation] +16];
		   tempString = nil;
		   [searchScanner scanUpToString:@"<" intoString:&tempString];
		   
		   if ([tempString rangeOfString:@"Widescreen Anamorphic"].location != NSNotFound)
			   [resultsDict setObject:@"Anamorphic Widescreen" forKey:@"pictureFormat"];
		   else if ([tempString rangeOfString:@"Pan &amp; Scan"].location != NSNotFound)
			   [resultsDict setObject:@"Pan & Scan" forKey:@"pictureFormat"];
		   else if ([tempString rangeOfString:@"LetterBox"].location != NSNotFound)
			   [resultsDict setObject:@"LetterBox" forKey:@"pictureFormat"];
		   else if ([tempString rangeOfString:@"Academy Ratio"].location != NSNotFound)
			   [resultsDict setObject:@"Academy Ratio" forKey:@"pictureFormat"];
		   else if ([tempString rangeOfString:@"Video"].location != NSNotFound)
			   [resultsDict setObject:@"Video" forKey:@"pictureFormat"];
		   else if ([tempString rangeOfString:@"Widescreen"].location != NSNotFound)
			   [resultsDict setObject:@"Widescreen" forKey:@"pictureFormat"];

		   
		   if ([tempString rangeOfString:@"2.35:1"].location != NSNotFound)
			   [resultsDict setObject:@"2.35:1" forKey:@"aspectRatio"];
		   else if ([tempString rangeOfString:@"1.33:1"].location != NSNotFound)
			   [resultsDict setObject:@"1.33:1" forKey:@"aspectRatio"];
		   else if ([tempString rangeOfString:@"1.78:1"].location != NSNotFound)
			   [resultsDict setObject:@"1.78:1" forKey:@"aspectRatio"];
		   else if ([tempString rangeOfString:@"1.66:1"].location != NSNotFound)
			   [resultsDict setObject:@"1.66:1" forKey:@"aspectRatio"];
		   else if ([tempString rangeOfString:@"1.85:1"].location != NSNotFound)
			   [resultsDict setObject:@"1.85:1" forKey:@"aspectRatio"];
		   else if ([tempString rangeOfString:@"2.40:1"].location != NSNotFound)
			   [resultsDict setObject:@"2.40:1" forKey:@"aspectRatio"];
		}
	   
	   
	   [searchScanner setScanLocation:0];
	   [searchScanner scanUpToString:@">DVD Features: </b>" intoString:nil];	   
	   if (![searchScanner isAtEnd]) {
		   [searchScanner setScanLocation:[searchScanner scanLocation] +19];
		   tempString = nil;
		   [searchScanner scanUpToString:@"<" intoString:&tempString];
		   
		   NSString *internalTempString = nil;
		   NSScanner *internalScanner = [NSScanner scannerWithString:tempString];
		   [internalScanner scanUpToString:@"Subtitles: " intoString:nil];	  
		   [internalScanner scanUpToString:@"Audio" intoString:&internalTempString];
		   if ([internalTempString hasPrefix:@"Subtitles: "]) {
			   internalTempString = [internalTempString substringFromIndex:11];
			   
			   if ([internalTempString hasSuffix:@", "])
				   internalTempString = [internalTempString substringToIndex:[internalTempString length] - 2];
			   
			   [resultsDict setValue:internalTempString forKey:@"subtitles"];
		   }
		   
		   NSMutableString *audio = [NSMutableString string];
		   [internalScanner setScanLocation:0];
		   while (![internalScanner isAtEnd]) {
			   internalTempString = nil;
			   [internalScanner scanUpToString:@"Audio Track" intoString:nil];	  
			   [internalScanner scanUpToString:@": " intoString:nil];	  
			   [internalScanner scanUpToString:@"Audio" intoString:&internalTempString];
			   if ([internalTempString hasPrefix:@": "]) {
				   NSMutableString *cleanAudio = [NSMutableString stringWithString:[internalTempString substringFromIndex:2]];
				   
				   if ([cleanAudio hasSuffix:@", Unknown, "])
					   [cleanAudio deleteCharactersInRange:NSMakeRange([cleanAudio length] - 11, 11)];
				   
				   if ([internalTempString hasSuffix:@", "])
					   [cleanAudio deleteCharactersInRange:NSMakeRange([cleanAudio length] - 2, 2)];
				   
				   [cleanAudio replaceOccurrencesOfString:@", " withString:@" " options:NSLiteralSearch range:NSMakeRange(0, [cleanAudio length])];
				   
				   if ([audio length] > 0)
					   [audio appendString:@", "];
				   
				   [audio appendString:cleanAudio];
			   }
			   
		   }
		   
		   if ([audio length] > 0) {
			   [resultsDict setValue:audio forKey:@"languages"];
			   
			   if ([audio rangeOfString:@"THX"].location != NSNotFound)
				   [resultsDict setObject:@"THX" forKey:@"sound"];
			   if ([audio rangeOfString:@"Dolby Digital 5.1"].location != NSNotFound)
				   [resultsDict setObject:@"Dolby Digital 5.1" forKey:@"sound"];
			   else if ([audio rangeOfString:@"DTS"].location != NSNotFound)
				   [resultsDict setObject:@"DTS" forKey:@"sound"];
			   else if ([audio rangeOfString:@"Dolby Digital 2.1"].location != NSNotFound)
				   [resultsDict setObject:@"Dolby Digital 2.1" forKey:@"sound"];
			   else if ([audio rangeOfString:@"Dolby Digital 2.0 Stereo"].location != NSNotFound)
				   [resultsDict setObject:@"Dolby Digital 2.0 Stereo" forKey:@"sound"];
			   else if ([audio rangeOfString:@"Dolby Digital 2.0 Surround"].location != NSNotFound)
				   [resultsDict setObject:@"Dolby Digital 2.0 Surround" forKey:@"sound"];
			   else if ([audio rangeOfString:@"Dolby Digital 2.0 Mono"].location != NSNotFound)
				   [resultsDict setObject:@"Dolby Digital 2.0 Mono" forKey:@"sound"];
			   else if ([audio rangeOfString:@"Dolby Digital 2.0"].location != NSNotFound)
				   [resultsDict setObject:@"Dolby Digital 2.0" forKey:@"sound"];

		   }
	   }
	   
	   
	   //Possible region add
	   
	   
	   
	   
	   [searchScanner setScanLocation:0];
	   [searchScanner scanUpToString:@">ASIN:</b> " intoString:nil];	   
	   if (![searchScanner isAtEnd]) {
		   [searchScanner setScanLocation:[searchScanner scanLocation] +11];
		   tempString = nil;
		   [searchScanner scanUpToString:@"</" intoString:&tempString];
		   [resultsDict setValue:tempString forKey:@"asin"];
	  
		   [self amazonImageForAsin:tempString toImageArray:imageLocationArray];	   
	   }
	   
	   
	   
	   
	      [searchScanner setScanLocation:0];
	   [searchScanner scanUpToString:@">UPC:</b> " intoString:nil];	   
	   if (![searchScanner isAtEnd]) {
		   [searchScanner setScanLocation:[searchScanner scanLocation] +10];
		   tempString = nil;
		   [searchScanner scanUpToString:@"<" intoString:&tempString];
		   [resultsDict setValue:tempString forKey:@"upc"];
	   }
	   
	   

	   
	   [searchScanner setScanLocation:0];
	   [searchScanner scanUpToString:@">Supplements<" intoString:nil];	   
	   if (![searchScanner isAtEnd]) {
		   tempString = nil;
		   [searchScanner scanUpToString:@"<hr />" intoString:&tempString];
		   
		   NSString *internalTempString = nil;
		   NSScanner *internalScanner = [NSScanner scannerWithString:tempString];
		   
		   [internalScanner scanUpToString:@"Subtitles: " intoString:nil];	  
		   [internalScanner scanUpToString:@"Audio" intoString:&internalTempString];
		   if ([internalTempString hasPrefix:@"Subtitles: "]) {
			   internalTempString = [internalTempString substringFromIndex:11];
			   
			   if ([internalTempString hasSuffix:@", "])
				   internalTempString = [internalTempString substringToIndex:[internalTempString length] - 2];
			   
			   [resultsDict setValue:internalTempString forKey:@"subtitles"];
		   }
		   
		   NSMutableString *audio = [NSMutableString string];
		   [internalScanner setScanLocation:0];
		   while (![internalScanner isAtEnd]) {
			   internalTempString = nil;
			   [internalScanner scanUpToString:@"<div class=\"dvd_row_alt\">" intoString:nil];	  
			   [internalScanner scanUpToString:@"class" intoString:nil];	  
			   [internalScanner scanUpToString:@"</div" intoString:&internalTempString];
			   if ([internalTempString hasPrefix:@"class=\"dvd_row_alt\">"]) {
				   internalTempString = [internalTempString substringFromIndex:20];
				   
				   if ([internalTempString hasPrefix:@"<b>Disc One: "])
					   internalTempString = [internalTempString substringFromIndex:13];
				   else if ([internalTempString hasPrefix:@"<b>Disc Two: "])
					   internalTempString = [internalTempString substringFromIndex:13];
				   else if ([internalTempString hasPrefix:@"<b>Disc Three: "])
					   internalTempString = [internalTempString substringFromIndex:15];
				   else if ([internalTempString hasPrefix:@"<b>Disc Four: "])
					   internalTempString = [internalTempString substringFromIndex:14];
				   
				   if ([audio length] > 0)
					   [audio appendString:@"\n"];
				   
				   [audio appendString:internalTempString];
			   }
			   
		   }
		   
		   if ([audio length] > 0) {
			   [audio replaceOccurrencesOfString:@"<i>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
			   [audio replaceOccurrencesOfString:@"</i>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
			   [audio replaceOccurrencesOfString:@"<I>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
			   [audio replaceOccurrencesOfString:@"</I>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
			   [audio replaceOccurrencesOfString:@"</b>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];
			   [audio replaceOccurrencesOfString:@"<b>" withString:@"" options:NSLiteralSearch range:NSMakeRange(0,[audio length])];

			   [resultsDict setValue:audio forKey:@"features"];
		   }
	   }

	return resultsDict;	   	
}



#pragma mark Connection Delegation
//***********************************************************************************************************
- (void)downloadWebPage:(NSString *)aWebPage {
	
	//Create request for http query
	NSURLRequest *httpRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:aWebPage] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:30.0];
	
	theConnection = [[NSURLConnection alloc] initWithRequest:httpRequest delegate:self];
	
	if (theConnection) {
		receivedData = [[NSMutableData alloc] init];
	}
	else {
		[delegate searchReturnedNumberOfResults:0 sender:self];
	}	
}

//***********************************************************************************************************
- (void)downloadWebPage:(NSString *)aWebPage withPost:(NSString *)body encoding:(int)anEncoding {
	//Create request for http query
	NSMutableURLRequest *postRequest = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:aWebPage] cachePolicy:NSURLRequestUseProtocolCachePolicy timeoutInterval:30.0];
	[postRequest setHTTPMethod: @"POST"];
	
	[postRequest setHTTPBody:[body dataUsingEncoding:anEncoding]];
	
	theConnection = [[NSURLConnection alloc] initWithRequest:postRequest delegate:self];
	
	if (theConnection) {
		receivedData = [[NSMutableData alloc] init];
	}
	else {
		[delegate searchReturnedNumberOfResults:0 sender:self];
	}	
	
}
//***********************************************************************************************************


/* If there are any redirects this notification is sent and we reset the data to 0  */
- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response
{
	//redirects and such
    [receivedData setLength:0];
}
//***********************************************************************************************************


- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data
{
    // append the new data to the receivedData
    [receivedData appendData:data];
}
//***********************************************************************************************************

- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error
{
    // release the connection, and the data object
    [connection release];
    [receivedData release];
	receivedData = nil;
	
	[delegate searchReturnedNumberOfResults:0 sender:self];
}
//***********************************************************************************************************

-(NSURLRequest *)connection:(NSURLConnection *)connection willSendRequest:(NSURLRequest *)request redirectResponse:(NSURLResponse *)redirectResponse {
	return request;
}
//***********************************************************************************************************

- (void)connectionDidFinishLoading:(NSURLConnection *)connection
{
	
	//NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	//Turn recievedData into a  string try NSUTF encoding if that fails use Latin
	//NSString *HTMLSource = [[[NSString alloc] initWithData:receivedData encoding:NSUTF8StringEncoding] autorelease];	
	//if (HTMLSource == nil)
		NSString *HTMLSource = [[[NSString alloc] initWithData:receivedData encoding:NSISOLatin1StringEncoding] autorelease];	
	
	
    // release the connection, and the data object
    [connection release];
    [receivedData release];
	receivedData = nil;
	
	//All encodings failed return no results otherwise parse
	if (HTMLSource == nil)
		[delegate searchReturnedNumberOfResults:0 sender:self];
	else
		[self downloadComplete:HTMLSource];
	
	//[pool release];
}


@end
