//
//  IMDBOptionsPanel.m
//  IMDB
//
//  Created by Conor Dearden on 17/8/06.
//  Copyright 2006 Chiguire LLC. All rights reserved.
//

#import "IMDBOptionsPanel.h"


@implementation IMDBOptionsPanel

- (void)showPreferences {
	
	NSUserDefaults *prefs = [NSUserDefaults standardUserDefaults];
	
	//set checkBox
	NSArray *prefsKeyArray = [NSArray arrayWithObjects:@"IMDBCreditsActors", @"IMDBCreditsUncredited", @"IMDBCreditsMusic", @"IMDBCreditsCinematographer", @"IMDBCreditsEditor", @"IMDBCreditsCasting", @"IMDBCreditsProductionDesigner", @"IMDBCreditsArtDirector", @"IMDBCreditsSet", @"IMDBCreditsCostume", @"IMDBCreditsMakeUp", @"IMDBCreditsProductionManager", @"IMDBCreditsAssistant", @"IMDBCreditsArt", @"IMDBCreditsSound", @"IMDBCreditsSpecial", @"IMDBCreditsVisual", @"IMDBCreditsProducedBy", @"IMDBCreditsStunts", @"IMDBCreditsElectrical", nil];
	int i, totalPrefs = [prefsKeyArray count];
    for (i =0; i < totalPrefs; i++) {
        [[preferenceMatrix cellAtRow:i column:0] setState:[[prefs objectForKey:[prefsKeyArray objectAtIndex:i]] boolValue]];
    }
	
	[plotKeywords setState:[[prefs objectForKey:@"IMDBAdditionalPlotKeywords"] boolValue]];

	
	if([plotKeywords state]) {
		[prefs setObject:[NSNumber numberWithBool:YES] forKey:@"IMDBAdditionalPlotKeywords"];
	}
	else {
		[prefs removeObjectForKey:@"IMDBAdditionalPlotKeywords"];
	}
	
	
	[NSApp beginSheet:self
       modalForWindow:[NSApp mainWindow]
        modalDelegate:NULL
       didEndSelector:NULL
          contextInfo:nil];
	
	[NSApp runModalForWindow:self];
	
	[NSApp endSheet:self];
	[self orderOut:NULL];
}


- (IBAction)setPreferences:(id)sender {
	
	NSUserDefaults *prefs = [NSUserDefaults standardUserDefaults];
	//set preference from check boxes
	
	//set checkBox
	NSArray *prefsKeyArray = [NSArray arrayWithObjects:@"IMDBCreditsActors", @"IMDBCreditsUncredited", @"IMDBCreditsMusic", @"IMDBCreditsCinematographer", @"IMDBCreditsEditor", @"IMDBCreditsCasting", @"IMDBCreditsProductionDesigner", @"IMDBCreditsArtDirector", @"IMDBCreditsSet", @"IMDBCreditsCostume", @"IMDBCreditsMakeUp", @"IMDBCreditsProductionManager", @"IMDBCreditsAssistant", @"IMDBCreditsArt", @"IMDBCreditsSound", @"IMDBCreditsSpecial", @"IMDBCreditsVisual", @"IMDBCreditsProducedBy",  @"IMDBCreditsStunts", @"IMDBCreditsElectrical", nil];
	BOOL haveToDownloadFull = NO;
	int i, totalPrefs = [prefsKeyArray count];
    for (i =0; i < totalPrefs; i++) {
		if ([[preferenceMatrix cellAtRow:i column:0] state]) {
			haveToDownloadFull = YES;
			[prefs setObject:[NSNumber numberWithBool:YES] forKey:[prefsKeyArray objectAtIndex:i]];
		}
		else {
			[prefs removeObjectForKey:[prefsKeyArray objectAtIndex:i]];
		}
    }
	
	if (haveToDownloadFull)
		[prefs setObject:[NSNumber numberWithBool:YES] forKey:@"IMDBCredits"];
	else
		[prefs removeObjectForKey:@"IMDBCredits"];
	
	// :ToIn:20090409 
	if([plotKeywords state]) {
		[prefs setObject:[NSNumber numberWithBool:YES] forKey:@"IMDBAdditionalPlotKeywords"];
	}
	else {
		[prefs removeObjectForKey:@"IMDBAdditionalPlotKeywords"];
	}
	

	[NSApp stopModal];
}

- (IBAction)cancel:(id)sender {
	[NSApp stopModal];
}

@end
